/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1. 0  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/name.h>
#include <dirent.h>
#include <malloc.h>
#include <sys/kernel.h>
#include <sys/psinfo.h>
#include <sys/seginfo.h>


/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"

char drive[20];
char form[20];

int locate_floppy(void);

int
format_floppy( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	DIR *dirp;
	struct dirent *direntp;
	char name[20];
	char *drives[10];
	int i;
	PtArg_t arg[1];

	for(i=0;i<10;i++)
		drives[i]=(char *)malloc(20);

	if(!locate_floppy())
		{
		PtAskQuestion(ABW_Format_floppy,"ERROR","Floppy Manager not started!",
			"helv14","&Cancel",NULL,NULL,1);
		exit(-1);
		}
	else
		{
		i=0;
		dirp=opendir("/dev");
		while(dirp!=NULL)
			{
			direntp=readdir(dirp);
			if(direntp==NULL)
				break;
			strcpy(name,direntp->d_name);
			if(!strncmp(name,"fd",2))
				{
				sprintf(drives[i],"/dev/%s",name);
				i++;
				}
			}
		closedir(dirp);
		PtSetArg(&arg[0],Pt_ARG_ITEMS,&drives,i);
		PtSetResources(ABW_listdrives,1,&arg[0]);
		PtFlush();
		}

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}


int locate_floppy(void)
	{
	int floppy=0;
	pid_t id=1;
	struct _psinfo data;

	while((id=qnx_psinfo(PROC_PID,id,&data,0,0))!=-1)
		{
		if((data.flags & (_PPF_MID|_PPF_VID))==0)
			{
			if(strstr(data.un.proc.name,"Fsys.floppy"))
				{
				floppy=1;
				}
			}
		++id;
		}			

	return(floppy);
	}
